#pragma once
//----------------------------------------
// macros offset specific to the layout used by file transfer element//


namespace ftsLayOutOffset{

	struct commonInfo
	{
	public:
		//int filename_fontheight_offset;

		int icon_file_type_width;
		int icon_file_type_height;
		int progressbar_width;
		int progressbar_height;
		int progressbar_top;
		int progressbar_to_bubble_left;
		int progressbar_to_bubble_right;
		int divider_width;
		int divider_height;
		int divider_height_offset;		//divide will draw on real postion( no same as DrawString, so must add offset);
		int divider_to_progressOrStatus_left;

		int button_to_divider_left;
		int icon_cancel_height;
		int icon_cancel_width;
		int filename_to_fileicon_top;
		REAL font_height; //px
		Gdiplus::Color clr_text_normal;
		Gdiplus::Color clr_text_link;
		Gdiplus::Color clr_progress_text;
		Gdiplus::Color clr_divider;

		virtual int GetFileIconWidth() const = 0;
		virtual int GetFileIconHeight() const = 0;
		virtual int GetFileIconEdgeX(BOOL bRight) const = 0;
		virtual int GetFileIconEdgeY() const = 0;
		virtual int GetFileNameInnerEdgeY() const 
		{
			return 0;
		}

		virtual int GetProgressbarWidth() const
		{
			return progressbar_width;
		}

		virtual int GetProgressbarHeight() const
		{
			return progressbar_height;
		}
	};

	struct sendInfo{
		int icon_to_item_top;
		int icon_to_item_left;
		int icon_to_item_bottom;

		//int filename_to_item_top;
		int filename_to_icon_left;
		int filename_to_icon_top;
		int filename_to_icon_right;
		int filename_to_item_right;
		Gdiplus::Color filename_color;
		int progress_to_cancel_right;
		//int progress_to_cancel_left;

		int progress_to_filename_top;

		int cancel_to_progress_right;
		int cancel_to_filename_bottom;
	};

	struct recvInfo {
		int icon_to_item_top;
		int icon_to_item_left;
		int icon_to_item_bottom;
		Gdiplus::Color filename_color;
		int left_corner_unvisible_width;

		int filename_to_icon_left;
		int filename_to_icon_top;
		int filename_to_item_right;

		int button_to_progress_right;
		int progress_to_filename_top;
		int progress_to_cancel_right;
	
		int button_down_width;
		int button_down_height;
	};

	struct Layout
	{
	public:
		Layout();
		virtual ~Layout();
		const commonInfo& common() const{ ASSERT(m_pCommonInfo); return *m_pCommonInfo; }
		const sendInfo& send() const { ASSERT(m_pSendInfo); return *m_pSendInfo; }
		const recvInfo& recv() const { ASSERT(m_pRecvInfo); return *m_pRecvInfo; }
	protected:
		commonInfo*	m_pCommonInfo;
		sendInfo*	m_pSendInfo;
		recvInfo*   m_pRecvInfo;
	};

	const Layout& GetCurrentLayout(int nDisplayType);
}